"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTypedQuery = exports.useTypedQueryOnce = void 0;
const firestore_1 = require("react-firebase-hooks/firestore");
const useSnapData_js_1 = require("./useSnapData.js");
const utils_js_1 = require("./utils.js");
const useTypedQueryOnce = (typedQuery, { getOptions, ...dataOptions } = {}) => {
    const { safeRef } = (0, utils_js_1.useRefChangeLimitExceeded)(typedQuery === null || typedQuery === void 0 ? void 0 : typedQuery.raw);
    const [_snap, loading, error] = (0, firestore_1.useCollectionOnce)(safeRef(), {
        getOptions,
    });
    (0, utils_js_1.useFirestoreErrorLogger)(error);
    const { snap, data } = (0, useSnapData_js_1.useQuerySnapData)(typedQuery, _snap, dataOptions);
    return { snap, data, loading, error };
};
exports.useTypedQueryOnce = useTypedQueryOnce;
const useTypedQuery = (typedQuery, { snapshotListenOptions, ...dataOptions } = {}) => {
    const { safeRef } = (0, utils_js_1.useRefChangeLimitExceeded)(typedQuery === null || typedQuery === void 0 ? void 0 : typedQuery.raw);
    const [_snap, loading, error] = (0, firestore_1.useCollection)(safeRef(), {
        snapshotListenOptions,
    });
    (0, utils_js_1.useFirestoreErrorLogger)(error);
    const { snap, data } = (0, useSnapData_js_1.useQuerySnapData)(typedQuery, _snap, dataOptions);
    return { snap, data, loading, error };
};
exports.useTypedQuery = useTypedQuery;
