import dayjs from 'dayjs';
import { CollectionReference, DocumentReference, Query } from 'firebase/firestore';
import { _web } from '../lib/firestore-types';
declare type RefOrQuery = DocumentReference | CollectionReference | Query;
export declare const useRefChangeLimitExceeded: <T extends RefOrQuery>(fref: T | null | undefined) => {
    exceeded: () => boolean;
    safeRef: () => T | null | undefined;
    timestamps: import("react").MutableRefObject<dayjs.Dayjs[]>;
};
export declare const useFirestoreErrorLogger: (error: _web.FirestoreError | undefined) => void;
export {};
