"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_hooks_1 = require("@testing-library/react-hooks");
const dayjs_1 = require("dayjs");
const firestore_1 = require("firebase/firestore");
const _app_js_1 = require("../__tests__/_infrastructure/_app.js");
const common_js_1 = require("../__tests__/_utils/common.js");
const utils_js_1 = require("./utils.js");
const logTimestamps = (timestamps) => {
    console.log(timestamps.map((a) => a.toISOString()), (0, dayjs_1.default)().toISOString());
};
const app = (0, _app_js_1.getTestAppWeb)('user').firestore();
const posts = (0, firestore_1.collection)(app, 'posts');
test('exceeded', async () => {
    const { result, rerender, unmount } = (0, react_hooks_1.renderHook)(() => {
        const date = (0, dayjs_1.default)().toDate();
        return (0, utils_js_1.useRefChangeLimitExceeded)((0, firestore_1.query)(posts, (0, firestore_1.where)('date', '==', date)));
    });
    rerender();
    await (0, common_js_1.sleep)(250);
    rerender();
    await (0, common_js_1.sleep)(250);
    rerender();
    await (0, common_js_1.sleep)(250);
    expect(result.current.timestamps.current.length).toBeGreaterThan(1);
    expect(result.current.exceeded()).toBe(true);
    expect(result.current.safeRef()).toBeFalsy();
    await (0, common_js_1.sleep)(5100);
    // logTimestamps(result.current.timestamps.current)
    expect(result.current.timestamps.current.length).toBeGreaterThan(1);
    expect(result.current.exceeded()).toBe(false);
    expect(result.current.safeRef()).toBeTruthy();
    unmount();
});
test('not exceeded', async () => {
    const date = (0, dayjs_1.default)().toDate();
    const { result, rerender, unmount } = (0, react_hooks_1.renderHook)(() => {
        return (0, utils_js_1.useRefChangeLimitExceeded)((0, firestore_1.query)(posts, (0, firestore_1.where)('date', '==', date)));
    });
    rerender();
    await (0, common_js_1.sleep)(500);
    expect(result.current.timestamps.current.length).toBe(1);
    expect(result.current.exceeded()).toBe(false);
    expect(result.current.safeRef()).toBeTruthy();
    await (0, common_js_1.sleep)(5100);
    expect(result.current.timestamps.current.length).toBe(1);
    expect(result.current.exceeded()).toBe(false);
    expect(result.current.safeRef()).toBeTruthy();
    unmount();
});
