import { useCollection, useCollectionOnce, } from 'react-firebase-hooks/firestore';
import { useQuerySnapData } from './useSnapData.js';
import { useFirestoreErrorLogger, useRefChangeLimitExceeded } from './utils.js';
export const useTypedQueryOnce = (typedQuery, { getOptions, ...dataOptions } = {}) => {
    const { safeRef } = useRefChangeLimitExceeded(typedQuery === null || typedQuery === void 0 ? void 0 : typedQuery.raw);
    const [_snap, loading, error] = useCollectionOnce(safeRef(), {
        getOptions,
    });
    useFirestoreErrorLogger(error);
    const { snap, data } = useQuerySnapData(typedQuery, _snap, dataOptions);
    return { snap, data, loading, error };
};
export const useTypedQuery = (typedQuery, { snapshotListenOptions, ...dataOptions } = {}) => {
    const { safeRef } = useRefChangeLimitExceeded(typedQuery === null || typedQuery === void 0 ? void 0 : typedQuery.raw);
    const [_snap, loading, error] = useCollection(safeRef(), {
        snapshotListenOptions,
    });
    useFirestoreErrorLogger(error);
    const { snap, data } = useQuerySnapData(typedQuery, _snap, dataOptions);
    return { snap, data, loading, error };
};
